C +++
C
C Source: src/source/r_inpsour.f
C
C ----------------------------------------------
C                SHADOW
C      Center for X-ray Lithography
C     University of Wisconsin-Madison
C  3731 Schneider Dr., Stoughton, WI, 53589
C ----------------------------------------------
C 
C Log: r_inpsour.f
C Revision 1.2  1991/07/06  19:59:53  khan
C Elliptical Undulator by Sylvia Difonzo
C
C Revision 1.1  90/07/10  14:56:42  khan
C Initial revision
C 
C 
C ---

C+++
C	PROGRAM		R_INPSOUR
C
C	PURPOSE		to start INPUT_SOURCE
C
C---
     	PROGRAM		R_INPSOUR
     	CALL	INPUT_SOURCE
     	STOP
     	END
 
        BLOCK DATA
	IMPLICIT        REAL*8          (A-E,G-H,O-Z)
	IMPLICIT        INTEGER*4       (F,I-N)

        COMMON /MATHBLK/ PI,TWOPI,PIHALF,TODEG,TORAD,ORIGIN(3),
     $                  X_VRS(3),Y_VRS(3),Z_VRS(3),TOCM,TOANGS
 
        DATA    PI      /  3.1415 92653 58979 32384 62643 D0 /
        DATA    PIHALF  /  1.5707 96326 79489 66192 31322 D0 /
        DATA    TWOPI   /  6.2831 85307 17958 64769 25287 D0 /
        DATA    TODEG   / 57.2957 79513 08232 08767 98155 D0 /
        DATA    TORAD   /  0.0174 53292 51994 32957 69237 D0 /
        DATA    TOCM    /  1.239 852    D-4                  /
        DATA    TOANGS  /  1.239 852    D+4                  /
 
        DATA    ORIGIN  /   .0D0, .0D0, .0D0                 /
 
        DATA    X_VRS   /  1.0D0,  .0D0,  .0D0               /
        DATA    Y_VRS   /   .0D0, 1.0D0,  .0D0               /
        DATA    Z_VRS   /   .0D0,  .0D0, 1.0D0               /
 
        COMMON  /CALC   /       NPOINT,NCOL,ISTAR1,IDO_X_S,IDO_Z_S,
     $                          IDO_Y_S,IDO_VZ,IDO_VX,IDO_XL,IDO_XN,
     $                          IDO_ZL,IDO_ZN,N_PLATES,IG_SEED,N_COLOR,
     $                          N_CIRCLE,N_CONE,N_SCREEN,I_SCREEN(10),
     $                          I_SLIT(10),K_SLIT(10),I_STOP(10),
     $                          I_ABS(10),MPURGE(2),NDEG,MOSAIC_SEED
        DATA    IDO_X_S,IDO_Y_S,IDO_Z_S,IDO_VX,IDO_VZ /1,1,1,1,1/
        DATA    ISTAR1          / 12345701 /
 
        END

