//
// exp2report.h: EXCON Report generator-specific decls
//
// ------------------------------------------------
// Mumit Khan <khan@xraylith.wisc.edu>
// Center for X-ray Lithography
// University of Wisconsin-Madison
// 3731 Schneider Dr., Stoughton, WI, 53589
// ------------------------------------------------
//
// Copyright (c) 1991-1996 Mumit Khan
//
//

#ifndef excon_exp2report_h
#define excon_exp2report_h

#include <string>

#include "exp.h"

// ===================================================================== //

//
// specializations to return the experiment inside the manager.
//
class Exp2ReportMgr : public ExpMgr {
public:
    Exp2ReportMgr() { }
    virtual ~Exp2ReportMgr() { }
    virtual const Exp* exp() const { return exp_; }
    virtual Exp* exp() { return exp_; }
};

extern int exp2report_init(int argc, char* argv[],
    std::string& toolsfile, std::string& expfile, std::string& output
);

// ===================================================================== //


#endif/*excon_ui_init_h*/
